<?php
use WHMCS\Database\Capsule;
function dnspodsld_MetaData()
{
    return array(
        'DisplayName' => 'DnspodSLD',
        'APIVersion' => '1.1', 
        'RequiresServer' => true
    );
}

function dnspodsld_ConfigOptions()
{
    return array(
        '域名前缀' => array(
            'Type' => 'text',
            'Size' => '500',
			'Default' => 'domain',
			'Description' => '域名结构:[域名前缀][随机生成或前台用户指定](域名后缀).主域名'
        ),
        '域名随机生成长度' => array(
            'Type' => 'text',
            'Size' => '500',
			'Default' => '5',
			'Description' => '域名结构:[域名前缀][随机生成或前台用户指定](域名后缀).主域名'
        ),
        '域名后缀' => array(
            'Type' => 'text',
            'Size' => '500',
			'Default' => '.user',
			'Description' => '域名结构:[域名前缀][随机生成或前台用户指定](域名后缀).主域名'
        )
    );
}

function dnspodsld_CreateAccount($params){
	if(@$params['customfields']['sstring']){
		$sstring = $params['customfields']['sstring'];
	}else{
		$sstring = dnspodsld_getRandomString($params['configoption2']);
	}
	if($params['configoptions']['maindomain']){
		$params['serverip'] = $params['configoptions']['maindomain'];
	}
	$DomainSubDomain = $params['configoption1'].$sstring.$params['configoption3'];
	$tempcurl = json_decode(dnspodsld_post('https://dnsapi.cn/Record.Create', array("lang" => 'cn',"login_token" => $params["serverusername"].','.$params["serverpassword"], "format" => 'json', "record_type" => 'A', "value" => '127.0.0.1', "record_line" => '默认', "sub_domain" => $DomainSubDomain, "domain" => $params['serverip'])),true);
    if(!$tempcurl){
        return '未返回任何有效信息,请检查您的网络';
    }
    if($tempcurl['status']['code'] != '1'){
		if(!$tempcurl['status']['message']){
			$errormsg = '未知错误';
		}else{
			$errormsg = $tempcurl['status']['message'];
		}
        return $errormsg;
    }
    if($tempcurl['record']['id']){
        Capsule::table('tblhosting')->where('id',$params['serviceid'])->update(['domain' => $DomainSubDomain.'.'.$params['serverip']]);
		Capsule::table('tblhosting')->where('id',$params['serviceid'])->update(['username' => $tempcurl['record']['id']]);
		$PasswdGenresults = localAPI('EncryptPassword',array('password2' => base64_encode(json_encode(array("type" => 'A',"value" => '127.0.0.1')))),Capsule::table('tbladmins')->first()->username);
        if($PasswdGenresults['result'] == 'success'){
		    Capsule::table('tblhosting')->where('id',$params['serviceid'])->update(['password' => $PasswdGenresults['password']]);
		}else{
			return '记录编码失败,开通失败';
		}
        return 'success';
    }else{
		return '未返回解析记录id,开通失败';
	}
}

function dnspodsld_SuspendAccount($params){
	if(!$params['username']){
		return '记录id不得为空';
	}
	if($params['configoptions']['maindomain']){
		$params['serverip'] = $params['configoptions']['maindomain'];
	}
	$tempcurl = json_decode(dnspodsld_post('https://dnsapi.cn/Record.Status', array("lang" => 'cn',"login_token" => $params["serverusername"].','.$params["serverpassword"], "format" => 'json', "status" => 'disable',"record_id" => $params['username'], "domain" => $params['serverip'])),true);
    if(!$tempcurl){
        return '未返回任何有效信息,请检查您的网络';
    }
    if($tempcurl['status']['code'] != '1'){
		if(!$tempcurl['status']['message']){
			$errormsg = '未知错误';
		}else{
			$errormsg = $tempcurl['status']['message'];
		}
        return $errormsg;
    }
    if($tempcurl['record']['id']){
		Capsule::table('tblhosting')->where('id',$params['serviceid'])->update(['username' => $tempcurl['record']['id']]);
        return 'success';
    }else{
		return '未返回解析记录id,失败';
	}
}

function dnspodsld_UnsuspendAccount($params){
	if(!$params['username']){
		return '记录id不得为空';
	}
	if($params['configoptions']['maindomain']){
		$params['serverip'] = $params['configoptions']['maindomain'];
	}
	$tempcurl = json_decode(dnspodsld_post('https://dnsapi.cn/Record.Status', array("lang" => 'cn',"login_token" => $params["serverusername"].','.$params["serverpassword"], "format" => 'json', "status" => 'enable',"record_id" => $params['username'], "domain" => $params['serverip'])),true);
    if(!$tempcurl){
        return '未返回任何有效信息,请检查您的网络';
    }
    if($tempcurl['status']['code'] != '1'){
		if(!$tempcurl['status']['message']){
			$errormsg = '未知错误';
		}else{
			$errormsg = $tempcurl['status']['message'];
		}
        return $errormsg;
    }
    if($tempcurl['record']['id']){
		Capsule::table('tblhosting')->where('id',$params['serviceid'])->update(['username' => $tempcurl['record']['id']]);
        return 'success';
    }else{
		return '未返回解析记录id,失败';
	}
}

function dnspodsld_TerminateAccount($params){
	if(!$params['username']){
		return '记录id不得为空';
	}
	if($params['configoptions']['maindomain']){
		$params['serverip'] = $params['configoptions']['maindomain'];
	}
	$tempcurl = json_decode(dnspodsld_post('https://dnsapi.cn/Record.Remove', array("lang" => 'cn',"login_token" => $params["serverusername"].','.$params["serverpassword"], "format" => 'json', "record_id" => $params['username'], "domain" => $params['serverip'])),true);
    if(!$tempcurl){
        return '未返回任何有效信息,请检查您的网络';
    }
    if($tempcurl['status']['code'] != '1'){
		if(!$tempcurl['status']['message']){
			$errormsg = '未知错误';
		}else{
			$errormsg = $tempcurl['status']['message'];
		}
        return $errormsg;
    }
    return 'success';
}

function dnspodsld_ClientAreaCustomButtonArray() {
    return array(
        '更改解析'   => "changevalue"
    );
}

function dnspodsld_changevalue($params){
	if($_REQUEST['ajax'] != 'true'){
		header('Location: /clientarea.php?action=productdetails&id='.$params['serviceid']);
		exit();
	}
	if(!$params['username']){
		exit(json_encode(array('result' => 'failed','msg' => '记录id不得为空')));
	}
	if($params['configoptions']['maindomain']){
		$params['serverip'] = $params['configoptions']['maindomain'];
	}
	if(substr($_REQUEST['domain_value'], -1) == '/'){
		$_REQUEST['domain_value'] = substr($_REQUEST['domain_value'],0,-1);
	}
	if(!trim($_REQUEST['domain_type']) || !trim($_REQUEST['domain_value'])){
		exit(json_encode(array('result' => 'failed','msg' => '解析类型和记录不能为空')));
	}
	$LocalValue = json_decode(base64_decode($params['password']),true);
	if($LocalValue['type'] == trim($_REQUEST['domain_type']) && $LocalValue['value'] == trim($_REQUEST['domain_value'])){
		exit(json_encode(array('result' => 'failed','msg' => '记录没有更改')));
	}else{
		if(trim($_REQUEST['domain_type']) == 'A' && !filter_var(trim($_REQUEST['domain_value']), FILTER_VALIDATE_IP)){
			exit(json_encode(array('result' => 'failed','msg' => '记录值错误')));
		}elseif(trim($_REQUEST['domain_type']) == 'CNAME' && !preg_match('/^http(s?):\/\/(?:[A-za-z0-9-]+\.)+[A-za-z]{2,4}(?:[\/\?#][\/=\?%\-&~`@[\]\':+!\.#\w]*)?$/','http://'.trim($_REQUEST['domain_value']))){
			exit(json_encode(array('result' => 'failed','msg' => '记录值错误')));
		}
	}
	$DomainSubDomain = str_replace('.'.$params['serverip'],"",$params['domain']);
	$tempcurl = json_decode(dnspodsld_post('https://dnsapi.cn/Record.Modify', array("lang" => 'cn',"login_token" => $params["serverusername"].','.$params["serverpassword"], "format" => 'json', "record_type" => trim($_REQUEST['domain_type']), "value" => trim($_REQUEST['domain_value']), "record_line" => '默认', "sub_domain" => $DomainSubDomain, "record_id" => $params['username'], "domain" => $params['serverip'])),true);
    if(!$tempcurl){
		exit(json_encode(array('result' => 'failed','msg' => '未返回任何有效信息,请检查您的网络')));
    }
    if($tempcurl['status']['code'] != '1'){
		if(!$tempcurl['status']['message']){
			$errormsg = '未知错误';
		}else{
			$errormsg = $tempcurl['status']['message'];
		}
		exit(json_encode(array('result' => 'failed','msg' => $errormsg)));
    }
    if($tempcurl['record']['id']){
		Capsule::table('tblhosting')->where('id',$params['serviceid'])->update(['username' => $tempcurl['record']['id']]);
		$PasswdGenresults = localAPI('EncryptPassword',array('password2' => base64_encode(json_encode(array("type" => trim($_REQUEST['domain_type']),"value" => trim($_REQUEST['domain_value']))))),Capsule::table('tbladmins')->first()->username);
        if($PasswdGenresults['result'] == 'success'){
		    Capsule::table('tblhosting')->where('id',$params['serviceid'])->update(['password' => $PasswdGenresults['password']]);
		}else{
			exit(json_encode(array('result' => 'failed','msg' => '记录编码失败,失败')));
		}
        exit(json_encode(array('result' => 'success')));
    }else{
		exit(json_encode(array('result' => 'failed','msg' => '未返回解析记录id,失败')));
	}
}

function dnspodsld_ClientArea($params){
	$LocalValue = json_decode(base64_decode($params['password']),true);
    return array(
        'tabOverviewReplacementTemplate' => 'templates/clientarea.tpl',
        'templateVariables' => array(
            'domain_type' => $LocalValue['type'],
            'domain_value' => $LocalValue['value']
        )
    );
}

function dnspodsld_post($url,$data){
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
    curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1);
    curl_setopt($curl, CURLOPT_AUTOREFERER, 1);
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    $tmpInfo = curl_exec($curl);
    curl_close($curl);
    return $tmpInfo;
}

function dnspodsld_getRandomString($len, $chars=null){  
    if (is_null($chars)) {  
        $chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";  
    }  
    mt_srand(10000000*(double)microtime());  
    for ($i = 0, $str = '', $lc = strlen($chars)-1; $i < $len; $i++) {  
        $str .= $chars[mt_rand(0, $lc)];  
    }  
    return $str;  
}